; VMM Basic example by Balrog Software
; Joystick and sprite example

Declare hScreen.l, hbm.l, EventID.l, Quit.b, X.l, Y.l, DC.l, text.s

If InitDXSprite() != 0

  MessageRequester("Sprites example", "Use Alt+F4 to exit...", #VMB_MESSAGEREQUESTER_OK)

  hScreen = OpenDXScreen(640, 480, 16, "ScriptVM - DirectX Test")

  If hScreen != 0 

    LoadDXSprite(1, "vmmb.bmp", #VMB_SPRITE_NORMAL)
    LoadDXSprite(2, "vmmb_small.bmp", #VMB_SPRITE_NORMAL)

    X=64 : Y=64
    
    ShowCursor(#False)
    
    Repeat

      ProcessEvent()
      EventID = MessageID()
      
      If EventID = #VMB_EVENT_CLOSE
        Quit = 1
      EndIf

      JoystickEvent(#VMB_JOYSTICK_ID0)

      X=X+JoystickAxisX(#VMB_JOYSTICK_ID0)
      Y=Y+JoystickAxisY(#VMB_JOYSTICK_ID0)

      If IsScreenActive(hScreen) = #True
        DrawDXSpriteFast(2, x, y)
        DrawDXSpriteFast(1, 200, 200)

        If SpriteDXCollisionFast(1, 200, 200, 2, x, y) = #True
          DC = GetDXScreenDC()
          Text(DC, 10, 10, "COLLISION", RGB(255, 255, 255))
          ReleaseDXScreenDC(DC)
        EndIf

        FlipDXBuffers(#VMB_SCREEN_CLEAR, RGB(0, 0, 255))
       
      EndIf
      
    Until Quit = 1
   
    ShowCursor(#True)

    CloseDXScreen()
    
  EndIf
Else
  MessageRequester("Error", "Can't initialise DirectX", #VMB_MESSAGEREQUESTER_OK)
EndIf

EndProgram
