; VMM Basic example by Balrog Software
; Sprite and 2d drawing example

Declare hScreen.l, hbm.l, EventID.l, Quit.b, xadd.l, DC.l, angle.f, circleangle.f, color.l, imageid.l, fps.l, fpstotal.l

If InitDXSprite() != #False 
  
  MessageRequester("Sprites example", "Use Alt+F4 to exit...", #VMB_MESSAGEREQUESTER_OK)

  hScreen = OpenDXScreen(640,480, 16, "VMM Basic - DirectX Test")

  If hScreen != #False And InitD3DSprite() != #False

    LoadDXSprite(1, "vmmb.bmp", #VMB_SPRITE_TEXTURE)

    LoadDXSprite(2, "advanced examples\gfx\explode1.bmp", #VMB_SPRITE_NORMAL)
    LoadDXSprite(3, "advanced examples\gfx\explode2.bmp", #VMB_SPRITE_NORMAL)
    LoadDXSprite(4, "advanced examples\gfx\explode3.bmp", #VMB_SPRITE_NORMAL)
    LoadDXSprite(5, "advanced examples\gfx\explode4.bmp", #VMB_SPRITE_NORMAL)

    CreateDXAnimation(1, 8, 2, 3, 4, 5)

    StartTimer(1)

    HideCursor(#True)
    
    Repeat

      ProcessEvent()

      EventID = MessageID()
      
      If EventID = #VMB_EVENT_CLOSE
        Quit = #True
      EndIf

      If IsScreenActive(hScreen)=#True
        
        FlipDXBuffers(#VMB_SCREEN_CLEAR, RGB(0, 0, 255))
    
        DC=GetDXScreenDC()
        
        Line(DC, 10, 30, 400, 432, RGB(255, 0, 255))
        Line(DC, 100, 400, 400, 10, RGB(255, 255, 0))
        
        For angle=0.0 To 6.28 Step 0.25
          Plot(DC, 300 + (50 * Cos(angle)), 200 + (50 * Sin(angle)), RGB(255, 255, 0))
        Next 
        
        Text(DC, 10, 10, Str(fpstotal), RGB(0, 255, 0))
        
        Add(circleangle, 0.1)
        If circleangle>=6.28 : circleangle=0.0 : EndIf
        Circle(DC, 300, 300, 40 + (Sin(circleangle)*50), 40, RGB(255, 0, 0))
        
        color=Point(DC, 100, 400)
        
        OutlinedBox(DC, 400, 100, 120, 120, color, RGB(255, 255, 255))

        ReleaseDXScreenDC(DC)

        If StartD3D()=#True
          DrawD3DRotatedTransparentSprite(1,0,0,100,100,200,circleangle)
          StopD3D()
        EndIf

        DrawDXSprite(1, 150 - xadd, 50, 100, xadd + 100)
   
        DrawDXTransparentSpriteFast(1, xadd + 400, 10)
        DrawDXTransparentSprite(1, xadd + 300, xadd + 180, xadd + 50, xadd + 50)
        DrawDXTransparentAnimationFast(1, 200, 200, #VMB_ANIMATION_PLAYLOOP)
        Add(fps,1)
        If GetTimer(1)>=1000 : fpstotal=fps : fps=0 : StartTimer(1) : EndIf
        xadd=xadd+1
        If xadd > 200 : xadd = 0 : EndIf
        
      EndIf
      
    Until Quit = #True
    
    HideCursor(#False)

    CloseDXScreen()
    
  EndIf
Else
  MessageRequester("Error","Can't initialise DirectX",0)
EndIf

EndProgram