; VMM Basic Tutorial 5

Declare Quit.b, hScreen.l, MotionPercent.l, DC.l

If InitDXSprite() != 0
  
  hScreen = OpenDXScreen(640, 480, 16, "VMM Basic Webcam tutorial")
  
  If hScreen != 0 
    
    SetVideoMode(#VMB_WEBCAM_VIDEOSTREAM)
    SetMotionDetection(#True, 20)
    
    InitWebcam(hScreen)
    
    WebcamRequester()
    
    SetAreaSize(640, 480)
    
    LoadDXSprite(0, "vmmb.bmp", #VMB_SPRITE_NORMAL)
    
    Repeat
      
      ProcessEvent()
      
      If KeyPushed(#VMB_KEY_ESCAPE) = #True
        Quit = 1
      EndIf
      
      If IsScreenActive(hScreen) = #True

        MotionPercent = CheckDXSpriteZoneFast(0, 100, 100)

        DC=GetDXScreenDC()
        DrawWebcamImage(DC, 0, 0, 640, 480)
        Text(DC, 10, 10, Add("CheckZone percent: ", Str(MotionPercent)), RGB(0,0,255))
        ReleaseDXScreenDC(DC)
        
        DrawDXSpriteFast(0, 100, 100)
        
        FlipDXBuffers(#VMB_SCREEN_CLEAR, RGB(0, 0, 255))
        
      EndIf
      
    Until Quit=1
    
    FreeDXSprite(0)
    
    FreeWebcam()

    CloseDXScreen()
    
  EndIf
  
EndIf

EndProgram
