; VMM Basic example by Balrog Software
; Motion detection example

Declare hScreen.l, hbm.l, EventID.l, Quit.b, DC.l, fps.l, fpsfinal.l, percent.l

If InitDXSprite() != 0
  
  MessageRequester("Motion detection example", "Push Escape to exit...", #VMB_MESSAGEREQUESTER_OK)
  
  hScreen = OpenDXScreen(640, 480, 16, "VM Basic - Motion detection")
  
  If hScreen != 0 

    SetVideoMode(#VMB_WEBCAM_VIDEOSTREAM)
    SetMotionDetection(#True,16)
    SetDetectionPrecision(#VMB_WEBCAM_HALFPRECISION)

    InitWebcam(hScreen)

    WebcamRequester()
    SetAreaSize(640, 480)
    
    HideCursor(#True)

    StartTimer(1)
    
    Repeat

      ProcessEvent()

      If KeyPushed(#VMB_KEY_ESCAPE)=#True
        Quit = 1
      EndIf
      
      If IsScreenActive(hScreen)=#True

        If GetTimer(1)>=1000
          fpsfinal=fps
          fps=0
          StartTimer(1)
        EndIf

        percent=CheckMotionZone(100,100,100,100)

        Add(fps,1)

        DC=GetDXScreenDC()
        DrawWebcamImage(DC,0,0,640,480)
        If percent>=3
          Box(DC, 100, 100, 100, 100, RGB(255,0,0))
        Else
          Box(DC, 100, 100, 100, 100, RGB(0,0,255))
        EndIf
        Text(DC, 10, 30, Add("Fps: ",Str(fpsfinal)), RGB(0,0,255))
        Text(DC, 10, 10, Add("CheckZone percent: ",Str(percent)), RGB(0,0,255))
        ReleaseDXScreenDC(DC)
        FlipDXBuffers(#VMB_SCREEN_CLEAR, RGB(0, 0, 0))

      EndIf
    
    Until Quit=1

    FreeWebcam()

    FreeTimer(1)

    HideCursor(#False)

    CloseDXScreen()

  EndIf
  
Else
  MessageRequester("Error", "Can't initialise DirectX", #VMB_MESSAGEREQUESTER_OK)
EndIf

EndProgram
