; VMM Basic Example by Balrog Software
; Window example

Declare hBmp1.l, hBmp2.l, Quit.b, Event.l, EvElem.l, hWindEvent.l, string.s, text.s, MenuId.l
Declare CheckBox.l, WindowX.l, WindowY.l, WindowWidth.l, WindowHeight.l, FileName.s, DC.l, Control.l

WindowWidth=320 : WindowHeight=180
WindowX=(GetSystemMetrics(#SM_CXSCREEN) / 2) - (WindowWidth / 2)
WindowY=(GetSystemMetrics(#SM_CYSCREEN) / 2) - (WindowHeight / 2)

If OpenWindow(0, WindowX, WindowY, 320, 180, "Window", FnOr(FnOr(#VMB_WINDOW_VISIBLE, #VMB_WINDOW_SYSTEMMENU), #VMB_WINDOW_MINIMIZE))!=0
  
  LoadBmpImage(1, "vmmb_small.bmp")  
  LoadBmpImage(2, "vmmb_small2.bmp") 
  
  CreateMenuBar(1)
  AddMenuItem(1, 1, "Load...")
  AddMenuSeparator(1)
  AddMenuItem(1, 2, "Quit")
  
  CreateMenuBar(2)
  AddMenuItem(2, 3, "Run")
  AddMenuSeparator(2)
  AddMenuItem(2, 4, "Compile")
  
  CreateMenuBar(3)
  AddMenuBar(3, "File", 1)
  AddMenuBar(3, "Compiler", 2)
  ShowWindowMenu(0, 3)
  
  CreateButton(0, 0, 190, 10, 110, 30, "Hello", #VMB_BUTTON_DEFAULT)
  CreateComboBox(0, 1, 190, 50, 110, 100, #VMB_COMBOBOX_DEFAULT)
  CreateImageButton(0, 2, 10, 10, 40, 40, 1, #VMB_IMAGEBUTTON_DEFAULT)
  CreateImageStatic(0, 3, 60, 13, 32, 32, 2, FnOr(#VMB_IMAGESTATIC_DEFAULT, #VMB_STATIC_BORDER))
  CreateEdit(0, 4, 10, 80, 290, 20, "Hi from editor", #VMB_EDIT_DEFAULT)
  CreateCheckBox(0, 5, 10, 50, 80, 30,"Check-Box", #VMB_CHECKBOX_DEFAULT)
  CreateRadioButton(0, 6, 100, 10, 80, 20, "Editor", #VMB_RADIOBUTTON_DEFAULT)
  CreateRadioButton(0, 7, 100, 30, 80, 20, "Compiler", #VMB_RADIOBUTTON_DEFAULT)
  CreateStatusBar(0, 8, "VMMB Status Bar!", #VMB_STATUSBAR_DEFAULT)
  CreateProgressBar(0, 9, 100, 55, 80, 15, #VMB_PROGRESSBAR_DEFAULT)
  CreateBalloonTip(2, 10, "Execute", "Execute program", #VMB_BALLOONTIP_INFOICO)
  PBSetState(9, 40)
 
  LoadFont(0, "New Times Roman", 10, #False, #False)
  
  For Control=0 To 8
    SetControlFont(Control, 0)
  Next
  
  CBAddText(1, "hi")
  CBAddText(1, "world")
  CBInsertText(1, 0, "VMM Basic rules!!!")
  CBSetSelectedItem(1, 0)
  
  Repeat
    
    WaitEvent()
    
    Event=MessageID()
    
    If Event=#VMB_EVENT_CLOSE
      Quit=1
    EndIf
    
    If Event=#VMB_EVENT_CONTROL
      
      EvElem=lParam()
      
      MenuID=GetMenuItem(wParam())
      
      If MenuID>0
        SetText(4, Add("Menu item ", Str(MenuID)))
      EndIf
      
      If EvElem=UseControl(0)
        FileName=LoadFileRequester("Open file", "c:\","text file;*.txt;all files;*.*;")
        If StringLength(FileName)!=0
          MessageRequester("Requester", FileName, #VMB_MESSAGEREQUESTER_OK) 
        EndIf 
      EndIf
      
      If EvElem=UseControl(1)
        SetText(4, Add("Combobox Item ", Str(CBGetSelectedItem(1))))
      EndIf
      
      If EvElem=UseControl(2)
        If RBGetState(6)=1
          RunProgram("..\vmmb editor.exe", "", "")
        EndIf
        If RBGetState(7)=1
          RunProgram("..\Compiler\VMMBComp.exe", "", "")
        EndIf
      EndIf
      
      If EvElem=UseControl(5)
        CheckBox=CBGetState(5)
        If CheckBox=1
          SetText(4, "Check-Box selected")
        Else
          SetText(4, "Check-Box unselected")
        EndIf
      EndIf
      
      If EvElem=UseControl(6)
        IBSetImage(2, 1)
        ISSetImage(3, 2)
        SetText(4, "VMMB Editor selected")
      EndIf
      
      If EvElem=UseControl(7)
        IBSetImage(2, 2)
        ISSetImage(3, 1)
        SetText(4, "VMMB Compiler selected")
      EndIf
      
    EndIf
    
  Until Quit=1
  
EndIf

EndProgram